unit UFFilmografie;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Grids, GLOBAL, ExtCtrls;

type
     TFilmo = record
          titel : string [100];
          jahr  : string [004];
     end;

  TFFilmografie = class(TForm)
    G: TStringGrid;
    laDarstellerAnz: TLabel;
    liDa: TComboBox;
    BuHinzufuegen: TButton;
    buLoeschen: TButton;
    liAlle: TFileListBox;
    laFilmanz: TLabel;
    liFilme: TListBox;
    Shape1: TShape;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure liDaClick(Sender: TObject);
    procedure BuHinzufuegenClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure buLoeschenClick(Sender: TObject);
    procedure GSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure GSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    dateiname : ansistring;
    anz : integer;
    f : file of TFilmo;
    arr : array of TFilmo;
    jetzt_nicht : boolean;
    procedure lesen;
    procedure schreiben;
    procedure uebertragen;
  end;

var
  FFilmografie: TFFilmografie;

implementation

uses UFNeueFilmografie, UFHaupt;

{$R *.lfm}

procedure TFFilmografie.lesen;

var
     j, k, p : integer;
     i    : tfilmo;

begin
     setlength (arr, 0);
     anz := 0;
     g.rowcount := 1;

     if   fileexists (dateiname) then
     begin
          assignfile (f, dateiname);
          reset (f);
          anz := filesize (f);
          setlength (arr, succ (anz));

          for  j := 1 to anz do
          begin
               read (f, i);
               p := j;

               for  k := 1 to pred (j)
               do   if   arr [k].titel > i.titel then
                    begin
                         p := k;
                         break;
                    end;

               if   p < j
               then move (arr [p], arr [succ (p)], (j - p) * sizeof (i));

               arr [p] := i;
          end;

          closefile (f);
     end;

     uebertragen;
end;




procedure TFFilmografie.schreiben;

var
     j : integer;

begin
     if   anz = 0
     then deletefile (dateiname)
     else
     begin
          assignfile (f, dateiname);
          rewrite (f);

          for  j := 1 to anz
          do   write (f, arr [j]);

          closefile (f);
     end;
end;




procedure TFFilmografie.uebertragen;

var
     j : integer;

begin
     g.cells [0, 0] := 'Lfd. Nr.';
     g.cells [1, 0] := 'Jahr';
     g.cells [2, 0] := 'Titel';

     g.cells [0, 1] := '';
     g.cells [1, 1] := '';
     g.cells [2, 1] := '';

     g.rowcount := succ (anz);

     for  j := 1 to anz do
     begin
          g.cells [0, j] := inttostr (j);
          g.cells [1, j] := arr [j].jahr;
          g.cells [2, j] := arr [j].titel;
     end;

     if   anz > 0 then
     begin
          g.fixedrows := 1;
          g.visible := true;
          g.row := 1;
          g.col := 2;
     end
     else g.visible := false;
end;




procedure TFFilmografie.FormCreate(Sender: TObject);

var
     j : integer;
     h : ansistring;

begin
     lialle.Directory := filmverz;

     for  j := 0 to pred (lialle.Items.Count) do
     begin
          h := lialle.items [j];
          setlength (h, length (h) - 4);

          lida.items.Add (h);
     end;

     jetzt_nicht := true;
     ladarstelleranz.caption := 'Anzahl: ' + inttostr (lida.items.count);
end;

procedure TFFilmografie.liDaClick(Sender: TObject);

var
     j : integer;

begin
     // Immer speichern, bevor neu geladen wird - Ausnahme beim ersten Mal
     if   not jetzt_nicht
     then schreiben;

     dateiname := filmverz + lida.items [lida.itemindex] + '.dat';
     lesen;
     jetzt_nicht := false;

     // Alle Filme für den Darsteller ermitteln und in die Listbox übertragen
     lifilme.clear;

     for  j := 1 to filesize (frec) do
     begin
          global.lesen (j);

          if   pos (uppercase (lida.items [lida.itemindex]), uppercase (rec.Darsteller)) > 0
          then lifilme.items.add (trim (rec.titel));
     end;

     if   lifilme.items.count = 1
     then lafilmanz.caption := 'Vorhandene Filme, in denen der Darsteller mitwirkt: (1 Film)'
     else lafilmanz.caption := 'Vorhandene Filme, in denen der Darsteller mitwirkt: (' + inttostr (lifilme.items.count) + ' Filme)';

     ladarstelleranz.caption := 'Anzahl: ' + inttostr (lida.items.count);
end;

procedure TFFilmografie.BuHinzufuegenClick(Sender: TObject);

var
     j, p : integer;
     s, jahr, titel : ansistring;
     verschieben, nehmen : boolean;

begin
     application.createform (TFNeueFilmografie, FNeueFilmografie);
     FNeueFilmografie.showmodal;

     if   FNeueFilmografie.ModalResult = mrok then
     begin // Alles in Gitter übertragen;
          for j := 0 to pred (FNeueFilmografie.memo.Lines.Count) do
          begin
               s := trim (FNeueFilmografie.memo.lines [j]);
               jahr  := copy (s, length (s) - 4, 4);
               titel := copy (s, 1, length (s) - 7);

               // Zuerst prüfen, ob der Titel bereits vorhanden ist - dann nicht nehmen
               p := 1;
               nehmen := true;

               while p <= anz
               do   if   uppercase (arr [p].titel) = uppercase (titel) then
                    begin
                         nehmen := false;
                         break;
                    end
                    else inc (p);

               // Alphabetische Position suchen, falls genommen werden soll
               if   nehmen then
               begin
                    p := 1;
                    verschieben := false;

                    while p <= anz
                    do   if   uppercase (arr [p].titel) > uppercase (titel)
                         then break
                         else inc (p);

                    if   p <= anz
                    then verschieben := true;

                    inc (anz);
                    setlength (arr, succ (anz));

                    if   verschieben
                    then move (arr [p], arr [succ (p)], (anz - p) * sizeof (arr [1]));

                    arr [p].jahr  := jahr;
                    arr [p].titel := titel;
               end;
          end;
     end;

     FNeueFilmografie.free;
     uebertragen;
end;

procedure TFFilmografie.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
     schreiben;
end;

procedure TFFilmografie.buLoeschenClick(Sender: TObject);

var
     p : integer;

begin
     if   g.Row > 0 then
     begin
          p := g.row;

          if   p < g.RowCount
          then move (arr [succ (p)], arr [p], (anz - p) * sizeof (arr [1]));

          dec (anz);
          setlength (arr, succ (anz));

          uebertragen;

          if   p  > g.rowcount
          then p := g.rowcount;

          g.row := p;
     end;
end;

procedure TFFilmografie.GSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);

var
     j : integer;

begin
     j := 0;

     while j < lifilme.items.count do
     begin
          if   uppercase (lifilme.items [j]) >= uppercase (g.cells [2, arow])
          then break
          else inc (j);
     end;

     lifilme.itemindex := j;
end;

procedure TFFilmografie.GSetEditText(Sender: TObject; ACol, ARow: Integer;
  const Value: String);
begin
     case acol of
          1 : arr [arow].jahr  := g.cells [acol, arow];
          2 : arr [arow].titel := g.cells [acol, arow];
     end;
end;

end.

